IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CTB_HIST_REC'  AND
	        TYPE = 'P' 			            AND
	        U.UID = O.UID             		AND
	        U.NAME = USER)

 DROP PROCEDURE CTB_HIST_REC
 GO

 CREATE PROCEDURE CTB_HIST_REC(
    @P_CDHISTPADR VARCHAR(4),
    @P_CDFILIAL VARCHAR(4),
    @P_NRLANCTONF VARCHAR(10),
    @P_NRSEQVENREC VARCHAR(2),
    @P_NRPARCELAREC VARCHAR(2),
    @P_CDAJUCTREC VARCHAR(4),
    @P_DSHISTPADR VARCHAR(200) OUTPUT )

AS
BEGIN
   DECLARE @V_DSHISTPADR VARCHAR(200); -- Varivel que ser retornada com o Historico
   DECLARE @V_DSAJUSTE VARCHAR(40);

   --Vriveis do cursor C_HIST
   DECLARE @C_HIST_NMRAZSOCCLIE VARCHAR(50);
   DECLARE @C_HIST_NMFANTCLIE VARCHAR(50);
   DECLARE @C_HIST_NRINSJURCLIE VARCHAR(20);
   DECLARE @C_HIST_CDFILIEMIT VARCHAR(4);
   DECLARE @C_HIST_NRNOTAFISC VARCHAR(20);
   DECLARE @C_HIST_NRLANCTONF VARCHAR(10);
   DECLARE @C_HIST_DSTPCTRECEB VARCHAR(40);
   DECLARE @C_HIST_DSCONTAREC VARCHAR(200);

   --Variveis do cursor C_FOS
   DECLARE @C_FOS_CDFILIAL VARCHAR(4);
   DECLARE @C_FOS_CDCAIXA VARCHAR(3);
   DECLARE @C_FOS_NRECFREDZ VARCHAR(10);
   DECLARE @C_FOS_NRREDREDZ VARCHAR(10);


   SELECT @V_DSHISTPADR = DSHISTPADR
     FROM HISTPADR
    WHERE CDHISTPADR = @P_CDHISTPADR;

    DECLARE C_HIST CURSOR FOR(
       SELECT CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.NRINSJURCLIE, NF.CDFILIEMIT, NF.NRNOTAFISC,
              NF.NRLANCTONF, TP.DSTPCTRECEB, CT.DSCONTAREC
         FROM CONTARECEBER CT, TIPOCTRECEBER TP, NOTAFISCAL NF, CLIENTE CL
        WHERE CT.CDFILIAL     = @P_CDFILIAL
          AND CT.NRLANCTONF   = @P_NRLANCTONF
          AND CT.NRSEQVENREC  = @P_NRSEQVENREC
          AND CT.NRPARCELAREC = @P_NRPARCELAREC
          AND CT.CDTPCTRECEB  = TP.CDTPCTRECEB
          AND CT.CDFILIAL     = NF.CDFILIAL
          AND CT.NRLANCTONF   = NF.NRLANCTONF
          AND NF.CDCLIENTE    = CL.CDCLIENTE
       )
       OPEN C_HIST;
       FETCH NEXT FROM C_HIST INTO  @C_HIST_NMRAZSOCCLIE, @C_HIST_NMFANTCLIE, @C_HIST_NRINSJURCLIE, @C_HIST_CDFILIEMIT,
                                    @C_HIST_NRNOTAFISC, @C_HIST_NRLANCTONF, @C_HIST_DSTPCTRECEB, @C_HIST_DSCONTAREC;

       WHILE (@@FETCH_STATUS = 0) BEGIN

          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[FIL]', ISNULL(@C_HIST_CDFILIEMIT,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[DOC]', ISNULL(@C_HIST_NRNOTAFISC,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[SEQ]', ISNULL(@C_HIST_NRLANCTONF,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[TCR]', ISNULL(@C_HIST_DSTPCTRECEB,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[DCR]', ISNULL(@C_HIST_DSCONTAREC,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[CLI]', ISNULL(@C_HIST_NRINSJURCLIE,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[NFC]', ISNULL(@C_HIST_NMFANTCLIE,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[RSC]', ISNULL(@C_HIST_NMRAZSOCCLIE,''));

          FETCH NEXT FROM C_HIST INTO  @C_HIST_NMRAZSOCCLIE, @C_HIST_NMFANTCLIE, @C_HIST_NRINSJURCLIE, @C_HIST_CDFILIEMIT,
                                       @C_HIST_NRNOTAFISC, @C_HIST_NRLANCTONF, @C_HIST_DSTPCTRECEB, @C_HIST_DSCONTAREC;


       END;
       CLOSE C_HIST;
       DEALLOCATE C_HIST;

       DECLARE C_FOS CURSOR FOR(
          SELECT DISTINCT MV.CDFILIAL,MV.CDCAIXA, R.NRECFREDZ, R.NRREDREDZ
            FROM MOVCAIXA MV, REDUCAOZ R
           WHERE MV.CDFILIALNF   = @P_CDFILIAL
             AND MV.NRLANCTONF   = @P_NRLANCTONF
             AND MV.CDFILIAL     = R.CDFILIAL
             AND MV.CDCAIXA      = R.CDCAIXA
             AND MV.DTMOVIMCAIXA = R.DTREDUCAOZ
           ) 
          OPEN C_FOS;
          FETCH NEXT FROM C_FOS INTO @C_FOS_CDFILIAL, @C_FOS_CDCAIXA, @C_FOS_NRECFREDZ, @C_FOS_NRREDREDZ;
          WHILE(@@FETCH_STATUS = 0) BEGIN

             SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[ECF]', ISNULL(@C_FOS_NRECFREDZ,''));
	          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[CXA]', ISNULL(@C_FOS_CDCAIXA,''));
	          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[RED]', ISNULL(@C_FOS_NRREDREDZ,''));

             FETCH NEXT FROM C_FOS INTO @C_FOS_CDFILIAL, @C_FOS_CDCAIXA, @C_FOS_NRECFREDZ, @C_FOS_NRREDREDZ;
          END;
          CLOSE C_FOS;
          DEALLOCATE C_FOS;

          IF @P_CDAJUCTREC IS NOT NULL BEGIN

             SELECT @V_DSAJUSTE = DSAJUCTREC
               FROM TIPOAJRECEBER
              WHERE CDAJUCTREC = @P_CDAJUCTREC;

          END;

          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[TAR]', ISNULL(@P_CDAJUCTREC,''));
          SET @V_DSHISTPADR = REPLACE(@V_DSHISTPADR, '[DAR]', ISNULL(@V_DSAJUSTE,''));

          SET @P_DSHISTPADR = @V_DSHISTPADR;

END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CTB_HIST_REC','5.50.000';
GO

